
drop database devdays11

create database devdays11
go

use devdays11
go

drop table dbo.webpages
create table dbo.webpages (
  id int identity not null,
  pagename nvarchar(128),
  filetype char(4),
  content varbinary(max),
    constraint pk_id primary key(id)
)
go

create table dbo.webpages2 (
  id int identity not null,
  pagename nvarchar(128),
  filetype char(4),
  content varbinary(max),
    constraint pk_id2 primary key(id)
)
go

create proc dbo.insert_page(@pagename nvarchar(128))
as
begin
declare @thesql nvarchar(max) = 
N'insert into webpages(pagename, filetype, content) 
  select ''' + @pagename + N''' AS pagename, 
         ''.htm'' AS filetype, 
         * from openrowset(bulk N''' + 'c:\temp\devdays11\' + @pagename + ''', single_blob) as content';
--print @thesql
exec(@thesql)
end
go

create proc dbo.insert_page2(@pagename nvarchar(128))
as
begin
declare @thesql nvarchar(max) = 
N'insert into webpages2(pagename, filetype, content) 
  select ''' + @pagename + N''' AS pagename, 
         ''.htm'' AS filetype, 
         * from openrowset(bulk N''' + 'c:\temp\devdays11\' + @pagename + ''', single_blob) as content';
--print @thesql
exec(@thesql)
end
go

exec insert_page N'TechDays 2011  DevDays Agenda.htm'
exec insert_page N'TechDays 2011  GeekNight Agenda.htm'
exec insert_page N'TechDays 2011  TechNet Live! Agenda.htm'
exec insert_page N'TechDays 2011 - FAQ.htm'
exec insert_page N'TechDays 2011 - FAQ_en.htm'
exec insert_page N'TechDays 2011 - FAQ_en_preconf.htm'
exec insert_page N'TechDays 2011 - Home.htm'
exec insert_page N'TechDays 2011 - Sprekers_Bob.htm'
go

exec insert_page2 N'TechDays 2011  DevDays Agenda.htm'
exec insert_page2 N'TechDays 2011  GeekNight Agenda.htm'
exec insert_page2 N'TechDays 2011  TechNet Live! Agenda.htm'
exec insert_page2 N'TechDays 2011 - FAQ.htm'
exec insert_page2 N'TechDays 2011 - FAQ_en.htm'
exec insert_page2 N'TechDays 2011 - FAQ_en_preconf.htm'
exec insert_page2 N'TechDays 2011 - Home.htm'
exec insert_page2 N'TechDays 2011 - Sprekers_Bob.htm'
go

create fulltext catalog ftcat as default
go

select * from sys.fulltext_languages

create fulltext index on dbo.webpages 
(
  content type column filetype 
  language Dutch 
)
key index pk_id;

create fulltext index on dbo.webpages2 
(
  content type column filetype 
  language English 
)
key index pk_id2;


select * from dbo.webpages where CONTAINS(*, N'Microsoft')
select * from dbo.webpages where CONTAINS(*, N' "Den Haag" ')
select * from dbo.webpages where CONTAINS(*, N' "Bob Beauchemin" ')

-- Difference in FTS parser or wordbreaker?

select * from dbo.webpages where CONTAINS(*, N'Pre-conference', LANGUAGE 1043)
select * from dbo.webpages where CONTAINS(*, N'Pre-conference', LANGUAGE 1033)
select * from dbo.webpages where CONTAINS(*, N'Preconference', LANGUAGE 1043)
select * from dbo.webpages where CONTAINS(*, N'Preconference', LANGUAGE 1033)

select * from dbo.webpages where FREETEXT(*, N'Preconference', LANGUAGE 1033)
select * from dbo.webpages where FREETEXT(*, N'Pre-conference', LANGUAGE 1033)
select * from dbo.webpages where FREETEXT(*, N'Pre conference', LANGUAGE 1033)
select * from dbo.webpages where FREETEXT(*, N'Preconference', LANGUAGE 1043)
select * from dbo.webpages where FREETEXT(*, N'Pre-conference', LANGUAGE 1043)
select * from dbo.webpages where FREETEXT(*, N'Pre conference', LANGUAGE 1043)

select * from dbo.webpages2 where CONTAINS(*, N'Pre-Conference', LANGUAGE 1043)
select * from dbo.webpages2 where CONTAINS(*, N'Pre-Conference', LANGUAGE 1033)
select * from dbo.webpages2 where CONTAINS(*, N'Preconference', LANGUAGE 1043)
select * from dbo.webpages2 where CONTAINS(*, N'Preconference', LANGUAGE 1033)

-- default wordbreaker language (but htm goes by ms-locale)
select * from dbo.webpages where CONTAINS(*, N'Pre-conference')
select * from dbo.webpages where CONTAINS(*, N'Preconference')
select * from dbo.webpages2 where CONTAINS(*, N'Pre-conference')
select * from dbo.webpages2 where CONTAINS(*, N'Preconference')

select * from sys.dm_fts_index_keywords( DB_ID('devdays11'), OBJECT_ID('dbo.webpages'))
where display_term like 'pre%'

select * from sys.dm_fts_index_keywords( DB_ID('devdays11'), OBJECT_ID('dbo.webpages2'))
where display_term like 'pre%'

select * from sys.dm_fts_parser(N'Pre-conference', 1033, 0, 0)
select * from sys.dm_fts_parser(N'Pre-conference', 1043, 0, 0)

select * from sys.dm_fts_parser(N'FORMSOF(FREETEXT,Pre-conference)', 1043, 0, 0)





